package rocks.zipcode.io.quiz3.arrays;

import com.sun.org.apache.xerces.internal.impl.xpath.regex.Match;
import com.sun.org.apache.xpath.internal.operations.Bool;

import java.util.ArrayList;
import java.util.Arrays;

/**
 * @author leon on 09/12/2018.
 */
public class TicTacToe {

    private String[][] tictac;

    public TicTacToe(String[][] board) {
        this.tictac = board;
    }

    public String[] getRow(Integer value) {

        ArrayList<String> rows = new ArrayList<>();

        for (int i = value; i <= value ; i++) {

            for (int j = 0; j < tictac.length ; j++) {
               rows.add(tictac[i][j]);
            }
        }

        String[] rowingArrays = new String[rows.size()];
        rowingArrays = rows.toArray(rowingArrays);
        return rowingArrays;
    }

    public String[] getColumn(Integer value) {

        String [] arr = new String[tictac.length];
        for (int i = 0; i <= tictac.length-1 ; i++) {

                arr[i] = tictac[i][value];



        }
        return arr;
    }
        //Homongenous means of the same type;
    public Boolean isRowHomogenous(Integer rowIndex) {
        String [] gettingrow = getRow(rowIndex);

        Boolean match = Arrays.stream(gettingrow).allMatch(s -> s.equals(gettingrow[0]));

        return match;
    }

    public Boolean isColumnHomogeneous(Integer columnIndex) {

        String [] gettingColumn = getColumn(columnIndex);

        Boolean match = Arrays.stream(gettingColumn).allMatch(s -> s.equals(gettingColumn[0]));

        return match;
    }

    public String getWinner()
    {
        String winner = "";

        int counter = 0;
        int counting = 0;

        for (int i = 0; i < tictac.length ; i++) {
            for (int j = 0; j < tictac.length ; j++) {

                if (tictac[i][j].equals("X")){
                    counter++;
                }else if(tictac[i][j].equals("O")){
                   counting ++;
                }
            }
            if(counter == 3){
                winner = "X";
            }else if(counting == 3){
                winner = "O";
            }
        }
        return winner;
    }
}
