package rocks.zipcode.io.quiz3.fundamentals;

import com.sun.org.apache.xpath.internal.operations.Bool;

/**
 * @author leon on 09/12/2018.
 */
public class VowelUtils {
    private static final char[] vowels = {'a','e','i','o','u','A','E','I','O','U'};

    public static Boolean hasVowels(String word) {
        return word.matches("[aeiou]");

    }

    public static Integer getIndexOfFirstVowel(String word) {

        final String vowel = "aeiou";

        for (int i = 0; i < word.length(); i++) {
            if(vowel.contains(String.valueOf(word.charAt(i))))
            {
                return i;
            }
        }
        return null;
    }


    public static Boolean startsWithVowel(String word) {

        Boolean flag = null;
        String smallword = word.toLowerCase();

        for (int i = 0; i <vowels.length ; i++) {
            if(smallword.charAt(0) == vowels[i]){
                return true;
            }else{
                flag = false;
            }
        }
        return flag;
    }

    public static Boolean isVowel(Character character) {

        Boolean flag = null;

        for (int i = 0; i <vowels.length ; i++) {
            if(character == vowels[i]){
                return true;
            }else{
                flag = false;
            }
        }
        return flag;
    }
}
